<stg><name>cache_module</name>


<trans_list>

<trans id="96" from="1" to="2">
<condition id="-1">
<or_exp><and_exp><literal name="updateDataValid_read" val="1"/>
</and_exp></or_exp>
</condition>
</trans>

<trans id="97" from="1" to="4">
<condition id="-1">
<or_exp><and_exp><literal name="updateDataValid_read" val="0"/>
</and_exp></or_exp>
</condition>
</trans>

<trans id="99" from="2" to="3">
<condition id="-1">
<or_exp><and_exp></and_exp></or_exp>
</condition>
</trans>

<trans id="100" from="3" to="4">
<condition id="-1">
<or_exp><and_exp></and_exp></or_exp>
</condition>
</trans>

<trans id="101" from="4" to="5">
<condition id="-1">
<or_exp><and_exp><literal name="updateTagValid_read" val="1"/>
</and_exp></or_exp>
</condition>
</trans>

<trans id="102" from="4" to="6">
<condition id="-1">
<or_exp><and_exp><literal name="updateTagValid_read" val="0"/>
</and_exp></or_exp>
</condition>
</trans>

<trans id="104" from="5" to="6">
<condition id="-1">
<or_exp><and_exp></and_exp></or_exp>
</condition>
</trans>

<trans id="105" from="6" to="7">
<condition id="-1">
<or_exp><and_exp></and_exp></or_exp>
</condition>
</trans>

<trans id="107" from="7" to="8">
<condition id="-1">
<or_exp><and_exp></and_exp></or_exp>
</condition>
</trans>
</trans_list>



<state_list>

<state id="1" st_id="1">

<operation id="9" st_id="1" stage="1" lat="1">
<core>NULL</core>
<MemPortIdVec></MemPortIdVec>
<condition id="-1">
<or_exp><and_exp></and_exp></or_exp>
</condition>

<Node id="12" bw="1" op_0_bw="1" op_1_bw="1">
<![CDATA[
entry:0 %updateDataValid_read = read i1 @_ssdm_op_Read.ap_auto.i1, i1 %updateDataValid

]]></Node>
<StgValue><ssdm name="updateDataValid_read"/></StgValue>
</operation>

<operation id="10" st_id="1" stage="1" lat="1">
<core>NULL</core>
<MemPortIdVec></MemPortIdVec>
<condition id="-1">
<or_exp><and_exp></and_exp></or_exp>
</condition>

<Node id="13" bw="1" op_0_bw="1" op_1_bw="1">
<![CDATA[
entry:1 %updateTagValid_read = read i1 @_ssdm_op_Read.ap_auto.i1, i1 %updateTagValid

]]></Node>
<StgValue><ssdm name="updateTagValid_read"/></StgValue>
</operation>

<operation id="11" st_id="1" stage="1" lat="1">
<core>NULL</core>
<MemPortIdVec></MemPortIdVec>
<condition id="-1">
<or_exp><and_exp></and_exp></or_exp>
</condition>

<Node id="14" bw="32" op_0_bw="32" op_1_bw="32">
<![CDATA[
entry:2 %newTag_read = read i32 @_ssdm_op_Read.ap_auto.i32, i32 %newTag

]]></Node>
<StgValue><ssdm name="newTag_read"/></StgValue>
</operation>

<operation id="12" st_id="1" stage="1" lat="1">
<core>NULL</core>
<MemPortIdVec></MemPortIdVec>
<condition id="-1">
<or_exp><and_exp></and_exp></or_exp>
</condition>

<Node id="15" bw="8" op_0_bw="8" op_1_bw="8">
<![CDATA[
entry:3 %updateWay_read = read i8 @_ssdm_op_Read.ap_auto.i8, i8 %updateWay

]]></Node>
<StgValue><ssdm name="updateWay_read"/></StgValue>
</operation>

<operation id="13" st_id="1" stage="1" lat="1">
<core>NULL</core>
<MemPortIdVec></MemPortIdVec>
<condition id="-1">
<or_exp><and_exp></and_exp></or_exp>
</condition>

<Node id="16" bw="8" op_0_bw="8" op_1_bw="8">
<![CDATA[
entry:4 %updateSet_read = read i8 @_ssdm_op_Read.ap_auto.i8, i8 %updateSet

]]></Node>
<StgValue><ssdm name="updateSet_read"/></StgValue>
</operation>

<operation id="14" st_id="1" stage="1" lat="1">
<core>NULL</core>
<MemPortIdVec></MemPortIdVec>
<condition id="-1">
<or_exp><and_exp></and_exp></or_exp>
</condition>

<Node id="17" bw="32" op_0_bw="32" op_1_bw="32">
<![CDATA[
entry:5 %address_read = read i32 @_ssdm_op_Read.ap_auto.i32, i32 %address

]]></Node>
<StgValue><ssdm name="address_read"/></StgValue>
</operation>

<operation id="15" st_id="1" stage="1" lat="1">
<core>NULL</core>
<MemPortIdVec></MemPortIdVec>
<condition id="-1">
<or_exp><and_exp></and_exp></or_exp>
</condition>

<Node id="18" bw="27" op_0_bw="32">
<![CDATA[
entry:6 %trunc_ln7 = trunc i32 %address_read

]]></Node>
<StgValue><ssdm name="trunc_ln7"/></StgValue>
</operation>

<operation id="16" st_id="1" stage="1" lat="1">
<core>NULL</core>
<MemPortIdVec></MemPortIdVec>
<condition id="-1">
<or_exp><and_exp></and_exp></or_exp>
</condition>

<Node id="19" bw="0" op_0_bw="0" op_1_bw="0">
<![CDATA[
entry:7 %spectopmodule_ln7 = spectopmodule void @_ssdm_op_SpecTopModule, void @empty_2

]]></Node>
<StgValue><ssdm name="spectopmodule_ln7"/></StgValue>
</operation>

<operation id="17" st_id="1" stage="1" lat="1">
<core>NULL</core>
<MemPortIdVec></MemPortIdVec>
<condition id="-1">
<or_exp><and_exp></and_exp></or_exp>
</condition>

<Node id="20" bw="0" op_0_bw="0" op_1_bw="32">
<![CDATA[
entry:8 %specbitsmap_ln0 = specbitsmap void @_ssdm_op_SpecBitsMap, i32 %address

]]></Node>
<StgValue><ssdm name="specbitsmap_ln0"/></StgValue>
</operation>

<operation id="18" st_id="1" stage="1" lat="1">
<core>NULL</core>
<MemPortIdVec></MemPortIdVec>
<condition id="-1">
<or_exp><and_exp></and_exp></or_exp>
</condition>

<Node id="21" bw="0" op_0_bw="0" op_1_bw="32" op_2_bw="0" op_3_bw="32" op_4_bw="32" op_5_bw="0" op_6_bw="32" op_7_bw="32" op_8_bw="0" op_9_bw="0" op_10_bw="0" op_11_bw="32" op_12_bw="32" op_13_bw="32" op_14_bw="32" op_15_bw="0" op_16_bw="0" op_17_bw="32" op_18_bw="32">
<![CDATA[
entry:9 %specinterface_ln0 = specinterface void @_ssdm_op_SpecInterface, i32 %address, void @empty, i32 0, i32 0, void @empty_0, i32 0, i32 0, void @empty_0, void @empty_0, void @empty_0, i32 0, i32 0, i32 0, i32 0, void @empty_0, void @empty_0, i32 4294967295, i32 0

]]></Node>
<StgValue><ssdm name="specinterface_ln0"/></StgValue>
</operation>

<operation id="19" st_id="1" stage="1" lat="1">
<core>NULL</core>
<MemPortIdVec></MemPortIdVec>
<condition id="-1">
<or_exp><and_exp></and_exp></or_exp>
</condition>

<Node id="22" bw="0" op_0_bw="0" op_1_bw="1">
<![CDATA[
entry:10 %specbitsmap_ln0 = specbitsmap void @_ssdm_op_SpecBitsMap, i1 %dirty

]]></Node>
<StgValue><ssdm name="specbitsmap_ln0"/></StgValue>
</operation>

<operation id="20" st_id="1" stage="1" lat="1">
<core>NULL</core>
<MemPortIdVec></MemPortIdVec>
<condition id="-1">
<or_exp><and_exp></and_exp></or_exp>
</condition>

<Node id="23" bw="0" op_0_bw="0" op_1_bw="1" op_2_bw="0" op_3_bw="32" op_4_bw="32" op_5_bw="0" op_6_bw="32" op_7_bw="32" op_8_bw="0" op_9_bw="0" op_10_bw="0" op_11_bw="32" op_12_bw="32" op_13_bw="32" op_14_bw="32" op_15_bw="0" op_16_bw="0" op_17_bw="32" op_18_bw="32">
<![CDATA[
entry:11 %specinterface_ln0 = specinterface void @_ssdm_op_SpecInterface, i1 %dirty, void @empty, i32 0, i32 0, void @empty_0, i32 0, i32 0, void @empty_0, void @empty_0, void @empty_0, i32 0, i32 0, i32 0, i32 0, void @empty_0, void @empty_0, i32 4294967295, i32 0

]]></Node>
<StgValue><ssdm name="specinterface_ln0"/></StgValue>
</operation>

<operation id="21" st_id="1" stage="1" lat="1">
<core>NULL</core>
<MemPortIdVec></MemPortIdVec>
<condition id="-1">
<or_exp><and_exp></and_exp></or_exp>
</condition>

<Node id="24" bw="0" op_0_bw="0" op_1_bw="1">
<![CDATA[
entry:12 %specbitsmap_ln0 = specbitsmap void @_ssdm_op_SpecBitsMap, i1 %hit

]]></Node>
<StgValue><ssdm name="specbitsmap_ln0"/></StgValue>
</operation>

<operation id="22" st_id="1" stage="1" lat="1">
<core>NULL</core>
<MemPortIdVec></MemPortIdVec>
<condition id="-1">
<or_exp><and_exp></and_exp></or_exp>
</condition>

<Node id="25" bw="0" op_0_bw="0" op_1_bw="1" op_2_bw="0" op_3_bw="32" op_4_bw="32" op_5_bw="0" op_6_bw="32" op_7_bw="32" op_8_bw="0" op_9_bw="0" op_10_bw="0" op_11_bw="32" op_12_bw="32" op_13_bw="32" op_14_bw="32" op_15_bw="0" op_16_bw="0" op_17_bw="32" op_18_bw="32">
<![CDATA[
entry:13 %specinterface_ln0 = specinterface void @_ssdm_op_SpecInterface, i1 %hit, void @empty, i32 0, i32 0, void @empty_0, i32 0, i32 0, void @empty_0, void @empty_0, void @empty_0, i32 0, i32 0, i32 0, i32 0, void @empty_0, void @empty_0, i32 4294967295, i32 0

]]></Node>
<StgValue><ssdm name="specinterface_ln0"/></StgValue>
</operation>

<operation id="23" st_id="1" stage="1" lat="1">
<core>NULL</core>
<MemPortIdVec></MemPortIdVec>
<condition id="-1">
<or_exp><and_exp></and_exp></or_exp>
</condition>

<Node id="26" bw="0" op_0_bw="0" op_1_bw="8">
<![CDATA[
entry:14 %specbitsmap_ln0 = specbitsmap void @_ssdm_op_SpecBitsMap, i8 %data

]]></Node>
<StgValue><ssdm name="specbitsmap_ln0"/></StgValue>
</operation>

<operation id="24" st_id="1" stage="1" lat="1">
<core>NULL</core>
<MemPortIdVec></MemPortIdVec>
<condition id="-1">
<or_exp><and_exp></and_exp></or_exp>
</condition>

<Node id="27" bw="0" op_0_bw="0" op_1_bw="8" op_2_bw="0" op_3_bw="32" op_4_bw="32" op_5_bw="0" op_6_bw="32" op_7_bw="32" op_8_bw="0" op_9_bw="0" op_10_bw="0" op_11_bw="32" op_12_bw="32" op_13_bw="32" op_14_bw="32" op_15_bw="0" op_16_bw="0" op_17_bw="32" op_18_bw="32">
<![CDATA[
entry:15 %specinterface_ln0 = specinterface void @_ssdm_op_SpecInterface, i8 %data, void @empty, i32 0, i32 0, void @empty_0, i32 0, i32 0, void @empty_0, void @empty_0, void @empty_0, i32 0, i32 0, i32 0, i32 0, void @empty_0, void @empty_0, i32 4294967295, i32 0

]]></Node>
<StgValue><ssdm name="specinterface_ln0"/></StgValue>
</operation>

<operation id="25" st_id="1" stage="1" lat="1">
<core>NULL</core>
<MemPortIdVec></MemPortIdVec>
<condition id="-1">
<or_exp><and_exp></and_exp></or_exp>
</condition>

<Node id="28" bw="0" op_0_bw="0" op_1_bw="8">
<![CDATA[
entry:16 %specbitsmap_ln0 = specbitsmap void @_ssdm_op_SpecBitsMap, i8 %updateSet

]]></Node>
<StgValue><ssdm name="specbitsmap_ln0"/></StgValue>
</operation>

<operation id="26" st_id="1" stage="1" lat="1">
<core>NULL</core>
<MemPortIdVec></MemPortIdVec>
<condition id="-1">
<or_exp><and_exp></and_exp></or_exp>
</condition>

<Node id="29" bw="0" op_0_bw="0" op_1_bw="8" op_2_bw="0" op_3_bw="32" op_4_bw="32" op_5_bw="0" op_6_bw="32" op_7_bw="32" op_8_bw="0" op_9_bw="0" op_10_bw="0" op_11_bw="32" op_12_bw="32" op_13_bw="32" op_14_bw="32" op_15_bw="0" op_16_bw="0" op_17_bw="32" op_18_bw="32">
<![CDATA[
entry:17 %specinterface_ln0 = specinterface void @_ssdm_op_SpecInterface, i8 %updateSet, void @empty, i32 0, i32 0, void @empty_0, i32 0, i32 0, void @empty_0, void @empty_0, void @empty_0, i32 0, i32 0, i32 0, i32 0, void @empty_0, void @empty_0, i32 4294967295, i32 0

]]></Node>
<StgValue><ssdm name="specinterface_ln0"/></StgValue>
</operation>

<operation id="27" st_id="1" stage="1" lat="1">
<core>NULL</core>
<MemPortIdVec></MemPortIdVec>
<condition id="-1">
<or_exp><and_exp></and_exp></or_exp>
</condition>

<Node id="30" bw="0" op_0_bw="0" op_1_bw="8">
<![CDATA[
entry:18 %specbitsmap_ln0 = specbitsmap void @_ssdm_op_SpecBitsMap, i8 %updateWay

]]></Node>
<StgValue><ssdm name="specbitsmap_ln0"/></StgValue>
</operation>

<operation id="28" st_id="1" stage="1" lat="1">
<core>NULL</core>
<MemPortIdVec></MemPortIdVec>
<condition id="-1">
<or_exp><and_exp></and_exp></or_exp>
</condition>

<Node id="31" bw="0" op_0_bw="0" op_1_bw="8" op_2_bw="0" op_3_bw="32" op_4_bw="32" op_5_bw="0" op_6_bw="32" op_7_bw="32" op_8_bw="0" op_9_bw="0" op_10_bw="0" op_11_bw="32" op_12_bw="32" op_13_bw="32" op_14_bw="32" op_15_bw="0" op_16_bw="0" op_17_bw="32" op_18_bw="32">
<![CDATA[
entry:19 %specinterface_ln0 = specinterface void @_ssdm_op_SpecInterface, i8 %updateWay, void @empty, i32 0, i32 0, void @empty_0, i32 0, i32 0, void @empty_0, void @empty_0, void @empty_0, i32 0, i32 0, i32 0, i32 0, void @empty_0, void @empty_0, i32 4294967295, i32 0

]]></Node>
<StgValue><ssdm name="specinterface_ln0"/></StgValue>
</operation>

<operation id="29" st_id="1" stage="1" lat="1">
<core>NULL</core>
<MemPortIdVec></MemPortIdVec>
<condition id="-1">
<or_exp><and_exp></and_exp></or_exp>
</condition>

<Node id="32" bw="0" op_0_bw="0" op_1_bw="32">
<![CDATA[
entry:20 %specbitsmap_ln0 = specbitsmap void @_ssdm_op_SpecBitsMap, i32 %newTag

]]></Node>
<StgValue><ssdm name="specbitsmap_ln0"/></StgValue>
</operation>

<operation id="30" st_id="1" stage="1" lat="1">
<core>NULL</core>
<MemPortIdVec></MemPortIdVec>
<condition id="-1">
<or_exp><and_exp></and_exp></or_exp>
</condition>

<Node id="33" bw="0" op_0_bw="0" op_1_bw="32" op_2_bw="0" op_3_bw="32" op_4_bw="32" op_5_bw="0" op_6_bw="32" op_7_bw="32" op_8_bw="0" op_9_bw="0" op_10_bw="0" op_11_bw="32" op_12_bw="32" op_13_bw="32" op_14_bw="32" op_15_bw="0" op_16_bw="0" op_17_bw="32" op_18_bw="32">
<![CDATA[
entry:21 %specinterface_ln0 = specinterface void @_ssdm_op_SpecInterface, i32 %newTag, void @empty, i32 0, i32 0, void @empty_0, i32 0, i32 0, void @empty_0, void @empty_0, void @empty_0, i32 0, i32 0, i32 0, i32 0, void @empty_0, void @empty_0, i32 4294967295, i32 0

]]></Node>
<StgValue><ssdm name="specinterface_ln0"/></StgValue>
</operation>

<operation id="31" st_id="1" stage="1" lat="1">
<core>NULL</core>
<MemPortIdVec></MemPortIdVec>
<condition id="-1">
<or_exp><and_exp></and_exp></or_exp>
</condition>

<Node id="34" bw="0" op_0_bw="0" op_1_bw="1">
<![CDATA[
entry:22 %specbitsmap_ln0 = specbitsmap void @_ssdm_op_SpecBitsMap, i1 %updateTagValid

]]></Node>
<StgValue><ssdm name="specbitsmap_ln0"/></StgValue>
</operation>

<operation id="32" st_id="1" stage="1" lat="1">
<core>NULL</core>
<MemPortIdVec></MemPortIdVec>
<condition id="-1">
<or_exp><and_exp></and_exp></or_exp>
</condition>

<Node id="35" bw="0" op_0_bw="0" op_1_bw="1" op_2_bw="0" op_3_bw="32" op_4_bw="32" op_5_bw="0" op_6_bw="32" op_7_bw="32" op_8_bw="0" op_9_bw="0" op_10_bw="0" op_11_bw="32" op_12_bw="32" op_13_bw="32" op_14_bw="32" op_15_bw="0" op_16_bw="0" op_17_bw="32" op_18_bw="32">
<![CDATA[
entry:23 %specinterface_ln0 = specinterface void @_ssdm_op_SpecInterface, i1 %updateTagValid, void @empty, i32 0, i32 0, void @empty_0, i32 0, i32 0, void @empty_0, void @empty_0, void @empty_0, i32 0, i32 0, i32 0, i32 0, void @empty_0, void @empty_0, i32 4294967295, i32 0

]]></Node>
<StgValue><ssdm name="specinterface_ln0"/></StgValue>
</operation>

<operation id="33" st_id="1" stage="1" lat="1">
<core>NULL</core>
<MemPortIdVec></MemPortIdVec>
<condition id="-1">
<or_exp><and_exp></and_exp></or_exp>
</condition>

<Node id="36" bw="0" op_0_bw="0" op_1_bw="8" op_2_bw="0" op_3_bw="32" op_4_bw="32" op_5_bw="0" op_6_bw="32" op_7_bw="32" op_8_bw="0" op_9_bw="0" op_10_bw="0" op_11_bw="32" op_12_bw="32" op_13_bw="32" op_14_bw="32" op_15_bw="0" op_16_bw="0" op_17_bw="32" op_18_bw="32">
<![CDATA[
entry:24 %specinterface_ln0 = specinterface void @_ssdm_op_SpecInterface, i8 %newData, void @empty_1, i32 0, i32 0, void @empty_0, i32 4294967295, i32 0, void @empty_0, void @empty_0, void @empty_0, i32 0, i32 0, i32 0, i32 0, void @empty_0, void @empty_0, i32 4294967295, i32 0

]]></Node>
<StgValue><ssdm name="specinterface_ln0"/></StgValue>
</operation>

<operation id="34" st_id="1" stage="1" lat="1">
<core>NULL</core>
<MemPortIdVec></MemPortIdVec>
<condition id="-1">
<or_exp><and_exp></and_exp></or_exp>
</condition>

<Node id="37" bw="0" op_0_bw="0" op_1_bw="8">
<![CDATA[
entry:25 %specbitsmap_ln0 = specbitsmap void @_ssdm_op_SpecBitsMap, i8 %newData

]]></Node>
<StgValue><ssdm name="specbitsmap_ln0"/></StgValue>
</operation>

<operation id="35" st_id="1" stage="1" lat="1">
<core>NULL</core>
<MemPortIdVec></MemPortIdVec>
<condition id="-1">
<or_exp><and_exp></and_exp></or_exp>
</condition>

<Node id="38" bw="0" op_0_bw="0" op_1_bw="1">
<![CDATA[
entry:26 %specbitsmap_ln0 = specbitsmap void @_ssdm_op_SpecBitsMap, i1 %updateDataValid

]]></Node>
<StgValue><ssdm name="specbitsmap_ln0"/></StgValue>
</operation>

<operation id="36" st_id="1" stage="1" lat="1">
<core>NULL</core>
<MemPortIdVec></MemPortIdVec>
<condition id="-1">
<or_exp><and_exp></and_exp></or_exp>
</condition>

<Node id="39" bw="0" op_0_bw="0" op_1_bw="1" op_2_bw="0" op_3_bw="32" op_4_bw="32" op_5_bw="0" op_6_bw="32" op_7_bw="32" op_8_bw="0" op_9_bw="0" op_10_bw="0" op_11_bw="32" op_12_bw="32" op_13_bw="32" op_14_bw="32" op_15_bw="0" op_16_bw="0" op_17_bw="32" op_18_bw="32">
<![CDATA[
entry:27 %specinterface_ln0 = specinterface void @_ssdm_op_SpecInterface, i1 %updateDataValid, void @empty, i32 0, i32 0, void @empty_0, i32 0, i32 0, void @empty_0, void @empty_0, void @empty_0, i32 0, i32 0, i32 0, i32 0, void @empty_0, void @empty_0, i32 4294967295, i32 0

]]></Node>
<StgValue><ssdm name="specinterface_ln0"/></StgValue>
</operation>

<operation id="37" st_id="1" stage="1" lat="1">
<core>NULL</core>
<MemPortIdVec></MemPortIdVec>
<condition id="-1">
<or_exp><and_exp></and_exp></or_exp>
</condition>

<Node id="40" bw="0" op_0_bw="0" op_1_bw="64">
<![CDATA[
entry:28 %specbramwithbyteenable_ln0 = specbramwithbyteenable void @_ssdm_op_SpecBRAMWithByteEnable, i64 %cacheMemory

]]></Node>
<StgValue><ssdm name="specbramwithbyteenable_ln0"/></StgValue>
</operation>

<operation id="38" st_id="1" stage="1" lat="1">
<core>NULL</core>
<MemPortIdVec></MemPortIdVec>
<condition id="-1">
<or_exp><and_exp></and_exp></or_exp>
</condition>

<Node id="41" bw="0" op_0_bw="1" op_1_bw="0" op_2_bw="0">
<![CDATA[
entry:29 %br_ln8 = br i1 %updateDataValid_read, void %if.end, void %if.then

]]></Node>
<StgValue><ssdm name="br_ln8"/></StgValue>
</operation>

<operation id="39" st_id="1" stage="1" lat="1">
<core>NULL</core>
<MemPortIdVec></MemPortIdVec>
<condition id="-1">
<or_exp><and_exp><literal name="updateDataValid_read" val="1"/>
</and_exp></or_exp>
</condition>

<Node id="43" bw="3" op_0_bw="8">
<![CDATA[
if.then:0 %trunc_ln9 = trunc i8 %updateSet_read

]]></Node>
<StgValue><ssdm name="trunc_ln9"/></StgValue>
</operation>

<operation id="40" st_id="1" stage="1" lat="1">
<core>NULL</core>
<MemPortIdVec></MemPortIdVec>
<condition id="-1">
<or_exp><and_exp><literal name="updateDataValid_read" val="1"/>
</and_exp></or_exp>
</condition>

<Node id="44" bw="6" op_0_bw="6" op_1_bw="3" op_2_bw="3">
<![CDATA[
if.then:1 %shl_ln9 = bitconcatenate i6 @_ssdm_op_BitConcatenate.i6.i3.i3, i3 %trunc_ln9, i3 0

]]></Node>
<StgValue><ssdm name="shl_ln9"/></StgValue>
</operation>

<operation id="41" st_id="1" stage="1" lat="1">
<core>NULL</core>
<MemPortIdVec></MemPortIdVec>
<condition id="-1">
<or_exp><and_exp><literal name="updateDataValid_read" val="1"/>
</and_exp></or_exp>
</condition>

<Node id="45" bw="3" op_0_bw="8">
<![CDATA[
if.then:2 %trunc_ln9_1 = trunc i8 %updateWay_read

]]></Node>
<StgValue><ssdm name="trunc_ln9_1"/></StgValue>
</operation>

<operation id="42" st_id="1" stage="1" lat="1">
<core>NULL</core>
<MemPortIdVec></MemPortIdVec>
<condition id="-1">
<or_exp><and_exp><literal name="updateDataValid_read" val="1"/>
</and_exp></or_exp>
</condition>

<Node id="46" bw="6" op_0_bw="6" op_1_bw="3" op_2_bw="3">
<![CDATA[
if.then:3 %shl_ln9_1 = bitconcatenate i6 @_ssdm_op_BitConcatenate.i6.i3.i3, i3 %trunc_ln9_1, i3 0

]]></Node>
<StgValue><ssdm name="shl_ln9_1"/></StgValue>
</operation>

<operation id="43" st_id="1" stage="1" lat="1">
<core>Adder</core>
<MemPortIdVec></MemPortIdVec>
<condition id="-1">
<or_exp><and_exp><literal name="updateDataValid_read" val="1"/>
</and_exp></or_exp>
</condition>

<Node id="47" bw="6" op_0_bw="6" op_1_bw="6">
<![CDATA[
if.then:4 %add_ln9 = add i6 %shl_ln9_1, i6 %shl_ln9

]]></Node>
<StgValue><ssdm name="add_ln9"/></StgValue>
</operation>

<operation id="44" st_id="1" stage="1" lat="1">
<core>NULL</core>
<MemPortIdVec></MemPortIdVec>
<condition id="-1">
<or_exp><and_exp><literal name="updateDataValid_read" val="1"/>
</and_exp></or_exp>
</condition>

<Node id="48" bw="3" op_0_bw="3" op_1_bw="6" op_2_bw="32" op_3_bw="32">
<![CDATA[
if.then:5 %lshr_ln9 = partselect i3 @_ssdm_op_PartSelect.i3.i6.i32.i32, i6 %add_ln9, i32 3, i32 5

]]></Node>
<StgValue><ssdm name="lshr_ln9"/></StgValue>
</operation>

<operation id="45" st_id="1" stage="1" lat="1">
<core>NULL</core>
<MemPortIdVec></MemPortIdVec>
<condition id="-1">
<or_exp><and_exp><literal name="updateDataValid_read" val="1"/>
</and_exp></or_exp>
</condition>

<Node id="49" bw="64" op_0_bw="3">
<![CDATA[
if.then:6 %zext_ln9 = zext i3 %lshr_ln9

]]></Node>
<StgValue><ssdm name="zext_ln9"/></StgValue>
</operation>

<operation id="46" st_id="1" stage="1" lat="1">
<core>NULL</core>
<MemPortIdVec></MemPortIdVec>
<condition id="-1">
<or_exp><and_exp><literal name="updateDataValid_read" val="1"/>
</and_exp></or_exp>
</condition>

<Node id="50" bw="3" op_0_bw="64" op_1_bw="64" op_2_bw="64">
<![CDATA[
if.then:7 %cacheMemory_addr = getelementptr i64 %cacheMemory, i64 0, i64 %zext_ln9

]]></Node>
<StgValue><ssdm name="cacheMemory_addr"/></StgValue>
</operation>

<operation id="47" st_id="1" stage="2" lat="2">
<core>RAM</core>
<MemPortIdVec></MemPortIdVec>
<condition id="-1">
<or_exp><and_exp><literal name="updateDataValid_read" val="1"/>
</and_exp></or_exp>
</condition>

<Node id="51" bw="64" op_0_bw="3">
<![CDATA[
if.then:8 %cacheMemory_load = load i3 %cacheMemory_addr

]]></Node>
<StgValue><ssdm name="cacheMemory_load"/></StgValue>
</operation>
</state>

<state id="2" st_id="2">

<operation id="48" st_id="2" stage="1" lat="2">
<core>RAM</core>
<MemPortIdVec></MemPortIdVec>
<condition id="-1">
<or_exp><and_exp></and_exp></or_exp>
</condition>

<Node id="51" bw="64" op_0_bw="3">
<![CDATA[
if.then:8 %cacheMemory_load = load i3 %cacheMemory_addr

]]></Node>
<StgValue><ssdm name="cacheMemory_load"/></StgValue>
</operation>

<operation id="49" st_id="2" stage="1" lat="1">
<core>NULL</core>
<MemPortIdVec></MemPortIdVec>
<condition id="-1">
<or_exp><and_exp></and_exp></or_exp>
</condition>

<Node id="52" bw="30" op_0_bw="30" op_1_bw="64" op_2_bw="32" op_3_bw="32">
<![CDATA[
if.then:9 %tmp_3 = partselect i30 @_ssdm_op_PartSelect.i30.i64.i32.i32, i64 %cacheMemory_load, i32 2, i32 31

]]></Node>
<StgValue><ssdm name="tmp_3"/></StgValue>
</operation>

<operation id="50" st_id="2" stage="1" lat="1">
<core>NULL</core>
<MemPortIdVec></MemPortIdVec>
<condition id="-1">
<or_exp><and_exp></and_exp></or_exp>
</condition>

<Node id="53" bw="32" op_0_bw="32" op_1_bw="30" op_2_bw="2">
<![CDATA[
if.then:10 %and_ln = bitconcatenate i32 @_ssdm_op_BitConcatenate.i32.i30.i2, i30 %tmp_3, i2 0

]]></Node>
<StgValue><ssdm name="and_ln"/></StgValue>
</operation>

<operation id="51" st_id="2" stage="1" lat="1">
<core>NULL</core>
<MemPortIdVec></MemPortIdVec>
<condition id="-1">
<or_exp><and_exp></and_exp></or_exp>
</condition>

<Node id="54" bw="32" op_0_bw="32" op_1_bw="32">
<![CDATA[
if.then:11 %or_ln10 = or i32 %and_ln, i32 1

]]></Node>
<StgValue><ssdm name="or_ln10"/></StgValue>
</operation>

<operation id="52" st_id="2" stage="1" lat="1">
<core>NULL</core>
<MemPortIdVec></MemPortIdVec>
<condition id="-1">
<or_exp><and_exp></and_exp></or_exp>
</condition>

<Node id="55" bw="64" op_0_bw="32">
<![CDATA[
if.then:12 %zext_ln10 = zext i32 %or_ln10

]]></Node>
<StgValue><ssdm name="zext_ln10"/></StgValue>
</operation>

<operation id="53" st_id="2" stage="1" lat="1">
<core>RAM</core>
<MemPortIdVec></MemPortIdVec>
<condition id="-1">
<or_exp><and_exp></and_exp></or_exp>
</condition>

<Node id="56" bw="0" op_0_bw="0" op_1_bw="3" op_2_bw="64" op_3_bw="8" op_4_bw="0">
<![CDATA[
if.then:13 %store_ln10 = store void @_ssdm_op_Write.bram.p0L_a8i8packedL, i3 %cacheMemory_addr, i64 %zext_ln10, i8 15

]]></Node>
<StgValue><ssdm name="store_ln10"/></StgValue>
</operation>
</state>

<state id="3" st_id="3">

<operation id="54" st_id="3" stage="1" lat="1">
<core>NULL</core>
<MemPortIdVec></MemPortIdVec>
<condition id="-1">
<or_exp><and_exp></and_exp></or_exp>
</condition>

<Node id="57" bw="6" op_0_bw="6" op_1_bw="6">
<![CDATA[
if.then:14 %or_ln11 = or i6 %add_ln9, i6 4

]]></Node>
<StgValue><ssdm name="or_ln11"/></StgValue>
</operation>

<operation id="55" st_id="3" stage="2" lat="2">
<core></core>
<MemPortIdVec></MemPortIdVec>
<condition id="-1">
<or_exp><and_exp></and_exp></or_exp>
</condition>

<Node id="58" bw="0" op_0_bw="0" op_1_bw="8" op_2_bw="6" op_3_bw="64" op_4_bw="0">
<![CDATA[
if.then:15 %call_ln11 = call void @cache_module_Pipeline_VITIS_LOOP_11_1, i8 %newData, i6 %or_ln11, i64 %cacheMemory

]]></Node>
<StgValue><ssdm name="call_ln11"/></StgValue>
</operation>
</state>

<state id="4" st_id="4">

<operation id="56" st_id="4" stage="1" lat="2">
<core></core>
<MemPortIdVec></MemPortIdVec>
<condition id="-1">
<or_exp><and_exp><literal name="updateDataValid_read" val="1"/>
</and_exp></or_exp>
</condition>

<Node id="58" bw="0" op_0_bw="0" op_1_bw="8" op_2_bw="6" op_3_bw="64" op_4_bw="0">
<![CDATA[
if.then:15 %call_ln11 = call void @cache_module_Pipeline_VITIS_LOOP_11_1, i8 %newData, i6 %or_ln11, i64 %cacheMemory

]]></Node>
<StgValue><ssdm name="call_ln11"/></StgValue>
</operation>

<operation id="57" st_id="4" stage="1" lat="1">
<core>NULL</core>
<MemPortIdVec></MemPortIdVec>
<condition id="-1">
<or_exp><and_exp><literal name="updateDataValid_read" val="1"/>
</and_exp></or_exp>
</condition>

<Node id="59" bw="0" op_0_bw="0">
<![CDATA[
if.then:16 %br_ln0 = br void %if.end

]]></Node>
<StgValue><ssdm name="br_ln0"/></StgValue>
</operation>

<operation id="58" st_id="4" stage="1" lat="1">
<core>NULL</core>
<MemPortIdVec></MemPortIdVec>
<condition id="-1">
<or_exp><and_exp></and_exp></or_exp>
</condition>

<Node id="61" bw="0" op_0_bw="1" op_1_bw="0" op_2_bw="0">
<![CDATA[
if.end:0 %br_ln14 = br i1 %updateTagValid_read, void %VITIS_LOOP_20_2, void %if.then19

]]></Node>
<StgValue><ssdm name="br_ln14"/></StgValue>
</operation>

<operation id="59" st_id="4" stage="1" lat="1">
<core>NULL</core>
<MemPortIdVec></MemPortIdVec>
<condition id="-1">
<or_exp><and_exp><literal name="updateTagValid_read" val="1"/>
</and_exp></or_exp>
</condition>

<Node id="63" bw="3" op_0_bw="8">
<![CDATA[
if.then19:0 %trunc_ln15 = trunc i8 %updateSet_read

]]></Node>
<StgValue><ssdm name="trunc_ln15"/></StgValue>
</operation>

<operation id="60" st_id="4" stage="1" lat="1">
<core>NULL</core>
<MemPortIdVec></MemPortIdVec>
<condition id="-1">
<or_exp><and_exp><literal name="updateTagValid_read" val="1"/>
</and_exp></or_exp>
</condition>

<Node id="64" bw="3" op_0_bw="8">
<![CDATA[
if.then19:1 %empty = trunc i8 %updateWay_read

]]></Node>
<StgValue><ssdm name="empty"/></StgValue>
</operation>

<operation id="61" st_id="4" stage="1" lat="1">
<core>Adder</core>
<MemPortIdVec></MemPortIdVec>
<condition id="-1">
<or_exp><and_exp><literal name="updateTagValid_read" val="1"/>
</and_exp></or_exp>
</condition>

<Node id="65" bw="3" op_0_bw="3" op_1_bw="3">
<![CDATA[
if.then19:2 %tmp = add i3 %empty, i3 %trunc_ln15

]]></Node>
<StgValue><ssdm name="tmp"/></StgValue>
</operation>

<operation id="62" st_id="4" stage="1" lat="1">
<core>NULL</core>
<MemPortIdVec></MemPortIdVec>
<condition id="-1">
<or_exp><and_exp><literal name="updateTagValid_read" val="1"/>
</and_exp></or_exp>
</condition>

<Node id="69" bw="27" op_0_bw="32">
<![CDATA[
if.then19:6 %trunc_ln15_1 = trunc i32 %newTag_read

]]></Node>
<StgValue><ssdm name="trunc_ln15_1"/></StgValue>
</operation>
</state>

<state id="5" st_id="5">

<operation id="63" st_id="5" stage="1" lat="1">
<core>NULL</core>
<MemPortIdVec></MemPortIdVec>
<condition id="-1">
<or_exp><and_exp></and_exp></or_exp>
</condition>

<Node id="66" bw="64" op_0_bw="3">
<![CDATA[
if.then19:3 %zext_ln15 = zext i3 %tmp

]]></Node>
<StgValue><ssdm name="zext_ln15"/></StgValue>
</operation>

<operation id="64" st_id="5" stage="1" lat="1">
<core>NULL</core>
<MemPortIdVec></MemPortIdVec>
<condition id="-1">
<or_exp><and_exp></and_exp></or_exp>
</condition>

<Node id="67" bw="3" op_0_bw="64" op_1_bw="64" op_2_bw="64">
<![CDATA[
if.then19:4 %cacheMemory_addr_1 = getelementptr i64 %cacheMemory, i64 0, i64 %zext_ln15

]]></Node>
<StgValue><ssdm name="cacheMemory_addr_1"/></StgValue>
</operation>

<operation id="65" st_id="5" stage="2" lat="2">
<core>RAM</core>
<MemPortIdVec></MemPortIdVec>
<condition id="-1">
<or_exp><and_exp></and_exp></or_exp>
</condition>

<Node id="68" bw="64" op_0_bw="3" op_1_bw="0" op_2_bw="0">
<![CDATA[
if.then19:5 %cacheMemory_load_1 = load i3 %cacheMemory_addr_1

]]></Node>
<StgValue><ssdm name="cacheMemory_load_1"/></StgValue>
</operation>
</state>

<state id="6" st_id="6">

<operation id="66" st_id="6" stage="1" lat="2">
<core>RAM</core>
<MemPortIdVec></MemPortIdVec>
<condition id="-1">
<or_exp><and_exp><literal name="updateTagValid_read" val="1"/>
</and_exp></or_exp>
</condition>

<Node id="68" bw="64" op_0_bw="3" op_1_bw="0" op_2_bw="0">
<![CDATA[
if.then19:5 %cacheMemory_load_1 = load i3 %cacheMemory_addr_1

]]></Node>
<StgValue><ssdm name="cacheMemory_load_1"/></StgValue>
</operation>

<operation id="67" st_id="6" stage="1" lat="1">
<core>NULL</core>
<MemPortIdVec></MemPortIdVec>
<condition id="-1">
<or_exp><and_exp><literal name="updateTagValid_read" val="1"/>
</and_exp></or_exp>
</condition>

<Node id="70" bw="3" op_0_bw="3" op_1_bw="64" op_2_bw="32" op_3_bw="32">
<![CDATA[
if.then19:7 %tmp_5 = partselect i3 @_ssdm_op_PartSelect.i3.i64.i32.i32, i64 %cacheMemory_load_1, i32 29, i32 31

]]></Node>
<StgValue><ssdm name="tmp_5"/></StgValue>
</operation>

<operation id="68" st_id="6" stage="1" lat="1">
<core>NULL</core>
<MemPortIdVec></MemPortIdVec>
<condition id="-1">
<or_exp><and_exp><literal name="updateTagValid_read" val="1"/>
</and_exp></or_exp>
</condition>

<Node id="71" bw="32" op_0_bw="32" op_1_bw="3" op_2_bw="27" op_3_bw="2">
<![CDATA[
if.then19:8 %tmp1 = bitconcatenate i32 @_ssdm_op_BitConcatenate.i32.i3.i27.i2, i3 %tmp_5, i27 %trunc_ln15_1, i2 0

]]></Node>
<StgValue><ssdm name="tmp1"/></StgValue>
</operation>

<operation id="69" st_id="6" stage="1" lat="1">
<core>NULL</core>
<MemPortIdVec></MemPortIdVec>
<condition id="-1">
<or_exp><and_exp><literal name="updateTagValid_read" val="1"/>
</and_exp></or_exp>
</condition>

<Node id="72" bw="32" op_0_bw="32" op_1_bw="32">
<![CDATA[
if.then19:9 %or_ln16 = or i32 %tmp1, i32 1

]]></Node>
<StgValue><ssdm name="or_ln16"/></StgValue>
</operation>

<operation id="70" st_id="6" stage="1" lat="1">
<core>NULL</core>
<MemPortIdVec></MemPortIdVec>
<condition id="-1">
<or_exp><and_exp><literal name="updateTagValid_read" val="1"/>
</and_exp></or_exp>
</condition>

<Node id="73" bw="64" op_0_bw="32">
<![CDATA[
if.then19:10 %zext_ln17 = zext i32 %or_ln16

]]></Node>
<StgValue><ssdm name="zext_ln17"/></StgValue>
</operation>

<operation id="71" st_id="6" stage="1" lat="1">
<core>RAM</core>
<MemPortIdVec></MemPortIdVec>
<condition id="-1">
<or_exp><and_exp><literal name="updateTagValid_read" val="1"/>
</and_exp></or_exp>
</condition>

<Node id="74" bw="0" op_0_bw="0" op_1_bw="3" op_2_bw="64" op_3_bw="8" op_4_bw="0" op_5_bw="0">
<![CDATA[
if.then19:11 %store_ln17 = store void @_ssdm_op_Write.bram.p0L_a8i8packedL, i3 %cacheMemory_addr_1, i64 %zext_ln17, i8 15

]]></Node>
<StgValue><ssdm name="store_ln17"/></StgValue>
</operation>

<operation id="72" st_id="6" stage="1" lat="1">
<core>NULL</core>
<MemPortIdVec></MemPortIdVec>
<condition id="-1">
<or_exp><and_exp><literal name="updateTagValid_read" val="1"/>
</and_exp></or_exp>
</condition>

<Node id="75" bw="0" op_0_bw="0">
<![CDATA[
if.then19:12 %br_ln18 = br void %VITIS_LOOP_20_2

]]></Node>
<StgValue><ssdm name="br_ln18"/></StgValue>
</operation>
</state>

<state id="7" st_id="7">

<operation id="73" st_id="7" stage="1" lat="1">
<core>NULL</core>
<MemPortIdVec></MemPortIdVec>
<condition id="-1">
<or_exp><and_exp></and_exp></or_exp>
</condition>

<Node id="77" bw="3" op_0_bw="3" op_1_bw="32" op_2_bw="32" op_3_bw="32">
<![CDATA[
VITIS_LOOP_20_2:0 %bf_lshr_cast = partselect i3 @_ssdm_op_PartSelect.i3.i32.i32.i32, i32 %address_read, i32 27, i32 29

]]></Node>
<StgValue><ssdm name="bf_lshr_cast"/></StgValue>
</operation>

<operation id="74" st_id="7" stage="1" lat="1">
<core>NULL</core>
<MemPortIdVec></MemPortIdVec>
<condition id="-1">
<or_exp><and_exp></and_exp></or_exp>
</condition>

<Node id="78" bw="64" op_0_bw="3">
<![CDATA[
VITIS_LOOP_20_2:1 %idxprom48 = zext i3 %bf_lshr_cast

]]></Node>
<StgValue><ssdm name="idxprom48"/></StgValue>
</operation>

<operation id="75" st_id="7" stage="1" lat="1">
<core>NULL</core>
<MemPortIdVec></MemPortIdVec>
<condition id="-1">
<or_exp><and_exp></and_exp></or_exp>
</condition>

<Node id="79" bw="3" op_0_bw="64" op_1_bw="64" op_2_bw="64">
<![CDATA[
VITIS_LOOP_20_2:2 %cacheMemory_addr_2 = getelementptr i64 %cacheMemory, i64 0, i64 %idxprom48

]]></Node>
<StgValue><ssdm name="cacheMemory_addr_2"/></StgValue>
</operation>

<operation id="76" st_id="7" stage="2" lat="2">
<core>RAM</core>
<MemPortIdVec></MemPortIdVec>
<condition id="-1">
<or_exp><and_exp></and_exp></or_exp>
</condition>

<Node id="80" bw="64" op_0_bw="3" op_1_bw="0" op_2_bw="0" op_3_bw="0">
<![CDATA[
VITIS_LOOP_20_2:3 %cacheMemory_load_2 = load i3 %cacheMemory_addr_2

]]></Node>
<StgValue><ssdm name="cacheMemory_load_2"/></StgValue>
</operation>
</state>

<state id="8" st_id="8">

<operation id="77" st_id="8" stage="1" lat="2">
<core>RAM</core>
<MemPortIdVec></MemPortIdVec>
<condition id="-1">
<or_exp><and_exp></and_exp></or_exp>
</condition>

<Node id="80" bw="64" op_0_bw="3" op_1_bw="0" op_2_bw="0" op_3_bw="0">
<![CDATA[
VITIS_LOOP_20_2:3 %cacheMemory_load_2 = load i3 %cacheMemory_addr_2

]]></Node>
<StgValue><ssdm name="cacheMemory_load_2"/></StgValue>
</operation>

<operation id="78" st_id="8" stage="1" lat="1">
<core>NULL</core>
<MemPortIdVec></MemPortIdVec>
<condition id="-1">
<or_exp><and_exp></and_exp></or_exp>
</condition>

<Node id="81" bw="1" op_0_bw="64">
<![CDATA[
VITIS_LOOP_20_2:4 %trunc_ln21 = trunc i64 %cacheMemory_load_2

]]></Node>
<StgValue><ssdm name="trunc_ln21"/></StgValue>
</operation>

<operation id="79" st_id="8" stage="1" lat="1">
<core>NULL</core>
<MemPortIdVec></MemPortIdVec>
<condition id="-1">
<or_exp><and_exp></and_exp></or_exp>
</condition>

<Node id="82" bw="0" op_0_bw="1" op_1_bw="0" op_2_bw="0">
<![CDATA[
VITIS_LOOP_20_2:5 %br_ln21 = br i1 %trunc_ln21, void %for.end99, void %land.lhs.true

]]></Node>
<StgValue><ssdm name="br_ln21"/></StgValue>
</operation>

<operation id="80" st_id="8" stage="1" lat="1">
<core>NULL</core>
<MemPortIdVec></MemPortIdVec>
<condition id="-1">
<or_exp><and_exp><literal name="trunc_ln21" val="1"/>
</and_exp></or_exp>
</condition>

<Node id="84" bw="27" op_0_bw="27" op_1_bw="64" op_2_bw="32" op_3_bw="32">
<![CDATA[
land.lhs.true:0 %trunc_ln21_3 = partselect i27 @_ssdm_op_PartSelect.i27.i64.i32.i32, i64 %cacheMemory_load_2, i32 2, i32 28

]]></Node>
<StgValue><ssdm name="trunc_ln21_3"/></StgValue>
</operation>

<operation id="81" st_id="8" stage="1" lat="1">
<core>Cmp</core>
<MemPortIdVec></MemPortIdVec>
<condition id="-1">
<or_exp><and_exp><literal name="trunc_ln21" val="1"/>
</and_exp></or_exp>
</condition>

<Node id="85" bw="1" op_0_bw="27" op_1_bw="27">
<![CDATA[
land.lhs.true:1 %icmp_ln21 = icmp_eq  i27 %trunc_ln21_3, i27 %trunc_ln7

]]></Node>
<StgValue><ssdm name="icmp_ln21"/></StgValue>
</operation>

<operation id="82" st_id="8" stage="1" lat="1">
<core>NULL</core>
<MemPortIdVec></MemPortIdVec>
<condition id="-1">
<or_exp><and_exp><literal name="trunc_ln21" val="1"/>
</and_exp></or_exp>
</condition>

<Node id="86" bw="0" op_0_bw="1" op_1_bw="0" op_2_bw="0">
<![CDATA[
land.lhs.true:2 %br_ln21 = br i1 %icmp_ln21, void %for.end99, void %cleanup

]]></Node>
<StgValue><ssdm name="br_ln21"/></StgValue>
</operation>

<operation id="83" st_id="8" stage="1" lat="1">
<core>NULL</core>
<MemPortIdVec></MemPortIdVec>
<condition id="-1">
<or_exp><and_exp><literal name="icmp_ln21" val="0"/>
</and_exp><and_exp><literal name="trunc_ln21" val="0"/>
</and_exp></or_exp>
</condition>

<Node id="88" bw="0" op_0_bw="0" op_1_bw="1" op_2_bw="1">
<![CDATA[
for.end99:0 %write_ln28 = write void @_ssdm_op_Write.ap_auto.i1P0A, i1 %hit, i1 0

]]></Node>
<StgValue><ssdm name="write_ln28"/></StgValue>
</operation>

<operation id="84" st_id="8" stage="1" lat="1">
<core>NULL</core>
<MemPortIdVec></MemPortIdVec>
<condition id="-1">
<or_exp><and_exp><literal name="icmp_ln21" val="0"/>
</and_exp><and_exp><literal name="trunc_ln21" val="0"/>
</and_exp></or_exp>
</condition>

<Node id="89" bw="0" op_0_bw="0">
<![CDATA[
for.end99:1 %br_ln29 = br void %return

]]></Node>
<StgValue><ssdm name="br_ln29"/></StgValue>
</operation>

<operation id="85" st_id="8" stage="1" lat="1">
<core>NULL</core>
<MemPortIdVec></MemPortIdVec>
<condition id="-1">
<or_exp><and_exp><literal name="trunc_ln21" val="1"/>
<literal name="icmp_ln21" val="1"/>
</and_exp></or_exp>
</condition>

<Node id="91" bw="0" op_0_bw="0" op_1_bw="1" op_2_bw="1">
<![CDATA[
cleanup:0 %write_ln22 = write void @_ssdm_op_Write.ap_auto.i1P0A, i1 %hit, i1 1

]]></Node>
<StgValue><ssdm name="write_ln22"/></StgValue>
</operation>

<operation id="86" st_id="8" stage="1" lat="1">
<core>NULL</core>
<MemPortIdVec></MemPortIdVec>
<condition id="-1">
<or_exp><and_exp><literal name="trunc_ln21" val="1"/>
<literal name="icmp_ln21" val="1"/>
</and_exp></or_exp>
</condition>

<Node id="92" bw="2" op_0_bw="2" op_1_bw="32" op_2_bw="32" op_3_bw="32">
<![CDATA[
cleanup:1 %tmp_6 = partselect i2 @_ssdm_op_PartSelect.i2.i32.i32.i32, i32 %address_read, i32 30, i32 31

]]></Node>
<StgValue><ssdm name="tmp_6"/></StgValue>
</operation>

<operation id="87" st_id="8" stage="1" lat="1">
<core>NULL</core>
<MemPortIdVec></MemPortIdVec>
<condition id="-1">
<or_exp><and_exp><literal name="trunc_ln21" val="1"/>
<literal name="icmp_ln21" val="1"/>
</and_exp></or_exp>
</condition>

<Node id="93" bw="6" op_0_bw="6" op_1_bw="1" op_2_bw="2" op_3_bw="3">
<![CDATA[
cleanup:2 %zext_ln23_cast = bitconcatenate i6 @_ssdm_op_BitConcatenate.i6.i1.i2.i3, i1 1, i2 %tmp_6, i3 0

]]></Node>
<StgValue><ssdm name="zext_ln23_cast"/></StgValue>
</operation>

<operation id="88" st_id="8" stage="1" lat="1">
<core>NULL</core>
<MemPortIdVec></MemPortIdVec>
<condition id="-1">
<or_exp><and_exp><literal name="trunc_ln21" val="1"/>
<literal name="icmp_ln21" val="1"/>
</and_exp></or_exp>
</condition>

<Node id="94" bw="64" op_0_bw="6">
<![CDATA[
cleanup:3 %zext_ln23 = zext i6 %zext_ln23_cast

]]></Node>
<StgValue><ssdm name="zext_ln23"/></StgValue>
</operation>

<operation id="89" st_id="8" stage="1" lat="1">
<core>Shifter</core>
<MemPortIdVec></MemPortIdVec>
<condition id="-1">
<or_exp><and_exp><literal name="trunc_ln21" val="1"/>
<literal name="icmp_ln21" val="1"/>
</and_exp></or_exp>
</condition>

<Node id="95" bw="64" op_0_bw="64" op_1_bw="64">
<![CDATA[
cleanup:4 %lshr_ln23 = lshr i64 %cacheMemory_load_2, i64 %zext_ln23

]]></Node>
<StgValue><ssdm name="lshr_ln23"/></StgValue>
</operation>

<operation id="90" st_id="8" stage="1" lat="1">
<core>NULL</core>
<MemPortIdVec></MemPortIdVec>
<condition id="-1">
<or_exp><and_exp><literal name="trunc_ln21" val="1"/>
<literal name="icmp_ln21" val="1"/>
</and_exp></or_exp>
</condition>

<Node id="96" bw="8" op_0_bw="64">
<![CDATA[
cleanup:5 %trunc_ln23 = trunc i64 %lshr_ln23

]]></Node>
<StgValue><ssdm name="trunc_ln23"/></StgValue>
</operation>

<operation id="91" st_id="8" stage="1" lat="1">
<core>NULL</core>
<MemPortIdVec></MemPortIdVec>
<condition id="-1">
<or_exp><and_exp><literal name="trunc_ln21" val="1"/>
<literal name="icmp_ln21" val="1"/>
</and_exp></or_exp>
</condition>

<Node id="97" bw="0" op_0_bw="0" op_1_bw="8" op_2_bw="8">
<![CDATA[
cleanup:6 %write_ln23 = write void @_ssdm_op_Write.ap_auto.i8P0A, i8 %data, i8 %trunc_ln23

]]></Node>
<StgValue><ssdm name="write_ln23"/></StgValue>
</operation>

<operation id="92" st_id="8" stage="1" lat="1">
<core>NULL</core>
<MemPortIdVec></MemPortIdVec>
<condition id="-1">
<or_exp><and_exp><literal name="trunc_ln21" val="1"/>
<literal name="icmp_ln21" val="1"/>
</and_exp></or_exp>
</condition>

<Node id="98" bw="1" op_0_bw="1" op_1_bw="64" op_2_bw="32">
<![CDATA[
cleanup:7 %tmp_1 = bitselect i1 @_ssdm_op_BitSelect.i1.i64.i32, i64 %cacheMemory_load_2, i32 1

]]></Node>
<StgValue><ssdm name="tmp_1"/></StgValue>
</operation>

<operation id="93" st_id="8" stage="1" lat="1">
<core>NULL</core>
<MemPortIdVec></MemPortIdVec>
<condition id="-1">
<or_exp><and_exp><literal name="trunc_ln21" val="1"/>
<literal name="icmp_ln21" val="1"/>
</and_exp></or_exp>
</condition>

<Node id="99" bw="0" op_0_bw="0" op_1_bw="1" op_2_bw="1">
<![CDATA[
cleanup:8 %write_ln24 = write void @_ssdm_op_Write.ap_auto.i1P0A, i1 %dirty, i1 %tmp_1

]]></Node>
<StgValue><ssdm name="write_ln24"/></StgValue>
</operation>

<operation id="94" st_id="8" stage="1" lat="1">
<core>NULL</core>
<MemPortIdVec></MemPortIdVec>
<condition id="-1">
<or_exp><and_exp><literal name="trunc_ln21" val="1"/>
<literal name="icmp_ln21" val="1"/>
</and_exp></or_exp>
</condition>

<Node id="100" bw="0" op_0_bw="0">
<![CDATA[
cleanup:9 %br_ln0 = br void %return

]]></Node>
<StgValue><ssdm name="br_ln0"/></StgValue>
</operation>

<operation id="95" st_id="8" stage="1" lat="1">
<core>NULL</core>
<MemPortIdVec></MemPortIdVec>
<condition id="-1">
<or_exp><and_exp></and_exp></or_exp>
</condition>

<Node id="102" bw="0">
<![CDATA[
return:0 %ret_ln29 = ret

]]></Node>
<StgValue><ssdm name="ret_ln29"/></StgValue>
</operation>
</state>
</state_list>


<ports>
</ports>


<dataflows>
</dataflows>


</stg>
